diff --git a/src/fsm.c b/src/fsm.c
index 603e8b440..c1f132a0c 100644
--- a/src/fsm.c
+++ b/src/fsm.c
@@ -3641,20 +4166,269 @@ ni_ifworker_bind_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_bool_t prompt_now)
 
 	if (w->device_api.factory_method && w->device_api.config) {
 		/* The XML validation code will do a pass over the part of our XML
-		 * document that's used for the deviceNew() call, and call us for
+		 * document that's used for the newDevice() call, and call us for
 		 * every bit of metadata it finds.
 		 * This includes elements marked by <meta:netif-reference/>
 		 * in the schema.
 		 */
-		if (!ni_dbus_xml_validate_argument(w->device_api.factory_method, 1, w->device_api.config, &context))
+		if (!ni_dbus_xml_validate_argument(w->device_api.factory_method,
+				1, w->device_api.config, &context))
 			return -NI_ERROR_DOCUMENT_ERROR;
 	}
 
-	ni_ifworker_get_check_state_req_for_methods(w);
+	/*
+	 * Also other methods as linkUp contain <meta:netif-reference/>
+	 * we have to resolve in order to rebuild the config hierarchy.
+	 */
+	ni_ifworker_bind_config_services_early(w, fsm, &context);
+
 done:
 	return rv;
 }
 
+struct process_system_requires_context {
+	ni_dbus_xml_traverse_context_t  base;
+	ni_fsm_t *			fsm;
+	ni_ifworker_t *			worker;
+	ni_ifworker_t *			linked;
+};
+
+static ni_bool_t
+ni_ifworker_meta_add_system_netif_check_state_require(ni_ifworker_t *w,
+		ni_ifworker_t *cw, xml_node_t *meta)
+{
+	ni_uint_range_t range = { NI_FSM_STATE_NONE, __NI_FSM_STATE_MAX };
+	const ni_fsm_transition_t *action;
+	const char *attr;
+
+	if (!(attr = xml_node_get_attr(meta, "op"))) {
+		ni_error("%s: invalid netif-check-state method=\"%s\"",
+				xml_node_location(meta), attr ?: "");
+		return FALSE;
+	}
+
+	action = ni_fsm_transition_find_method(attr);
+	if (!action || !ni_fsm_transition_is_down(action))
+		return FALSE;
+
+	attr = xml_node_get_attr(meta, "min-state");
+	if (attr && !ni_ifworker_state_from_name(attr, &range.min)) {
+		ni_error("%s: invalid state name min-state=\"%s\"",
+				xml_node_location(meta), attr);
+		return FALSE;
+	}
+
+	attr = xml_node_get_attr(meta, "max-state");
+	if (attr && !ni_ifworker_state_from_name(attr, &range.max)) {
+		ni_error("%s: invalid state name max-state=\"%s\"",
+				xml_node_location(meta), attr);
+		return FALSE;
+	}
+
+	ni_ifworker_add_system_check_state_req(w,
+		action->common.method_name, cw,
+		range.min, range.max);
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_ifworker_meta_add_system_netif_require(ni_ifworker_t *w,
+		ni_ifworker_t *cw, xml_node_t *meta)
+{
+	const char *check;
+
+	check = xml_node_get_attr(meta, "check");
+	if (ni_string_eq(check, "netif-check-state")) {
+		ni_ifworker_meta_add_system_netif_check_state_require(
+			w, cw, meta
+		);
+	}
+	return TRUE;
+}
+
+static dbus_bool_t
+process_system_requires(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *prev,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	const ni_dbus_xml_traverse_path_t path = { .prev = prev, .name = name };
+	ni_stringbuf_t buf = NI_STRINGBUF_INIT_DYNAMIC;
+	struct process_system_requires_context *ctx;
+	ni_bool_t subordinate = FALSE;	/* port -> master */
+	ni_bool_t shared = FALSE;	/* link -> lower  */
+	ni_netdev_ref_t *ref = NULL;
+	xml_node_t *meta;
+	const char *attr;
+
+	/* cast and verify it's the effective context */
+	ctx = (struct process_system_requires_context *)context;
+	if (context->process != process_system_requires)
+		return FALSE; /* something wrong; abort */
+
+	/* make sure we have some metadata node */
+	if (!type->meta || !type->meta->children)
+		return TRUE; /* don't abort processing */
+
+	ni_debug_wicked_xml(type->meta, NI_LOG_DEBUG3, "%s(%s) property meta",
+			__func__, ni_dbus_xml_traverse_path_print(&buf, &path));
+	ni_stringbuf_destroy(&buf);
+
+	/* little paranoia guard before accessing them */
+	if (!ctx->worker->device || !ctx->linked->device)
+		return TRUE; /* don't abort processing */
+
+	if (!(meta = xml_node_get_child(type->meta, "netif-reference")))
+		return TRUE; /* don't abort processing */
+
+	if ((attr = xml_node_get_attr(meta, "subordinate")))
+		subordinate = ni_string_eq(attr, "true");
+	if (!subordinate && (attr = xml_node_get_attr(meta, "shared")))
+		shared = ni_string_eq(attr, "true");
+
+	if (subordinate) {
+		ref = &ctx->linked->device->link.masterdev;
+		if (!ni_string_eq(ctx->worker->device->name, ref->name))
+			return TRUE; /* don't abort processing */
+
+		for (meta = type->meta->children; meta; meta = meta->next) {
+			if (ni_string_eq(meta->name, "require")) {
+				ni_ifworker_meta_add_system_netif_require(
+					ctx->linked, ctx->worker, meta
+				);
+			}
+		}
+	} else if (shared) {
+		ref = &ctx->linked->device->link.lowerdev;
+		if (!ni_string_eq(ctx->worker->device->name, ref->name))
+			return TRUE; /* don't abort processing */
+
+		for (meta = type->meta->children; meta; meta = meta->next) {
+			if (ni_string_eq(meta->name, "require")) {
+				ni_ifworker_meta_add_system_netif_require(
+					ctx->worker, ctx->linked, meta
+				);
+			}
+		}
+	}
+
+	return TRUE;
+}
+
+int
+ni_ifworker_bind_system_netif_ref_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_ifworker_t *ref)
+{
+	struct process_system_requires_context context = {
+		.base = {
+			.process = process_system_requires,
+		},
+		.fsm = fsm,
+		.worker = w,
+		.linked = ref,
+	};
+	const ni_dbus_service_t *service;
+	const ni_dbus_class_t *class;
+	int rv = NI_SUCCESS;
+
+	/*
+	 * the object is bound to the netif-<iftype> class/service
+	 * which extends the generic netif service (superclass).
+	 */
+	class = ref->object->class;
+	if (class && (service = ni_objectmodel_service_by_class(class))) {
+		rv = ni_dbus_xml_traverse_service_properties(service,
+				&context.base);
+		if (rv < NI_SUCCESS)
+			return rv;
+	}
+
+	if (ref->device->link.type != NI_IFTYPE_UNKNOWN && class->superclass &&
+	    (service = ni_objectmodel_service_by_class(class->superclass))) {
+		rv = ni_dbus_xml_traverse_service_properties(service,
+				&context.base);
+		if (rv < NI_SUCCESS)
+			return rv;
+	}
+
+	return rv;
+}
+
+int
+ni_ifworker_bind_system_links_early(ni_ifworker_t *w, ni_fsm_t *fsm)
+{
+	const ni_netdev_ref_t *lower;
+	ni_ifworker_t *link;
+	int rv = NI_SUCCESS;
+	unsigned int i;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		link = fsm->workers.data[i];
+
+		if (!link || !link->device || !link->object)
+			continue;
+
+		lower = &link->device->link.lowerdev;
+		if (!ni_string_eq(lower->name, w->name))
+			continue;
+
+		rv = ni_ifworker_bind_system_netif_ref_early(w, fsm, link);
+		if (rv < NI_SUCCESS)
+			return rv;
+	}
+	return rv;
+}
+
+int
+ni_ifworker_bind_system_ports_early(ni_ifworker_t *w, ni_fsm_t *fsm)
+{
+	const ni_netdev_ref_t *master;
+	ni_ifworker_t *port;
+	int rv = NI_SUCCESS;
+	unsigned int i;
+
+	for (i = 0; i < fsm->workers.count; ++i) {
+		port = fsm->workers.data[i];
+
+		if (!port || !port->device || !port->object)
+			continue;
+
+		master = &port->device->link.masterdev;
+		if (!ni_string_eq(master->name, w->name))
+			continue;
+
+		rv = ni_ifworker_bind_system_netif_ref_early(w, fsm, port);
+		if (rv < NI_SUCCESS)
+			return rv;
+	}
+	return rv;
+}
+
+int
+ni_ifworker_bind_system_early(ni_ifworker_t *w, ni_fsm_t *fsm)
+{
+	int rv = NI_SUCCESS;
+
+	ni_ifworker_bind_system_links_early(w, fsm);
+	ni_ifworker_bind_system_ports_early(w, fsm);
+
+	return rv;
+}
+
+int
+ni_ifworker_bind_early(ni_ifworker_t *w, ni_fsm_t *fsm, ni_bool_t prompt_now)
+{
+	int rv;
+
+	ni_ifworker_bind_system_early(w, fsm);
+
+	rv = ni_ifworker_bind_config_early(w, fsm, prompt_now);
+	if (rv < NI_SUCCESS)
+		return rv;
+
+	ni_ifworker_get_check_state_req_for_methods(w);
+	return rv;
+}
+
 /*
  * Build the hierarchy of devices.
  *
@@ -3662,6 +4436,14 @@ done:
  * eth interface needs to come up before any of the VLANs that reference
  * it.
  */
+#define ni_fsm_print_hierarchy(logfn, fmt, args...)		\
+	do {							\
+		if (logfn)					\
+			logfn(fmt, ##args);			\
+		else						\
+			ni_debug_application(fmt, ##args);	\
+	} while (0)
+
 static const char *
 ni_fsm_print_worker_name_info(ni_stringbuf_t *info, const ni_ifworker_t *w)
 {
@@ -3678,8 +4460,20 @@ ni_fsm_print_worker_name_info(ni_stringbuf_t *info, const ni_ifworker_t *w)
 	return info->string;
 }
 
+static const char *
+ni_fsm_config_hierarchy_mark(const ni_ifworker_array_t *marked,
+	const ni_ifworker_t *w)
+{
+	if (w && marked && ni_ifworker_array_index(marked, w) != -1)
+		return "+ ";
+	else
+		return "  ";
+}
+
 static void
-ni_fsm_print_config_device_worker_hierarchy(const ni_ifworker_t *w, unsigned int depth)
+ni_fsm_print_config_device_worker_hierarchy(const ni_fsm_t *fsm,
+		const ni_ifworker_t *w, unsigned int depth,
+		const ni_ifworker_array_t *marked, ni_log_fn_t *logfn)
 {
 	ni_stringbuf_t info = NI_STRINGBUF_INIT_DYNAMIC;
 	unsigned int i;
@@ -3688,35 +4482,52 @@ ni_fsm_print_config_device_worker_hierarchy(const ni_ifworker_t *w, unsigned int
 		return;
 
 	if (!depth) {
-		ni_debug_application("%s", ni_fsm_print_worker_name_info(&info, w));
+		ni_fsm_print_hierarchy(logfn, "%s%s",
+			ni_fsm_config_hierarchy_mark(marked, w),
+			ni_fsm_print_worker_name_info(&info, w));
 		ni_stringbuf_destroy(&info);
 	}
 
 	depth += 4;
-	for (i = 0; i < w->children.count; i++) {
-		ni_ifworker_t *c = w->children.data[i];
+	for (i = 0; i < fsm->workers.count; ++i) {
+		ni_ifworker_t *c = fsm->workers.data[i];
 
 		if (!c || c->type != w->type)
 			continue;
 
-		if (c->masterdev == w)
-			ni_debug_application("%*s %s", depth, "*--", ni_fsm_print_worker_name_info(&info, c));
-		else if (w->lowerdev == c)
-			ni_debug_application("%*s %s", depth, "+--", ni_fsm_print_worker_name_info(&info, c));
-		else /* unknown/other relation ?!? */
-			ni_debug_application("%*s %s", depth, "?--", ni_fsm_print_worker_name_info(&info, c));
+		if (w->lowerdev == c) {
 
-		ni_stringbuf_destroy(&info);
-		ni_fsm_print_config_device_worker_hierarchy(c, depth + 1);
+			ni_fsm_print_hierarchy(logfn, "%s%*s %s",
+					ni_fsm_config_hierarchy_mark(marked, c),
+					depth, "+--",
+					ni_fsm_print_worker_name_info(&info, c));
+			ni_stringbuf_destroy(&info);
+
+			ni_fsm_print_config_device_worker_hierarchy(fsm, c,
+					depth + 1, marked, logfn);
+			continue;
+		}
+		if (c->masterdev == w) {
+
+			ni_fsm_print_hierarchy(logfn, "%s%*s %s",
+					ni_fsm_config_hierarchy_mark(marked, c),
+					depth, "*--",
+					ni_fsm_print_worker_name_info(&info, c));
+			ni_stringbuf_destroy(&info);
+
+			ni_fsm_print_config_device_worker_hierarchy(fsm, c,
+					depth + 1, marked, logfn);
+		}
 	}
 }
 
 void
-ni_fsm_print_config_hierarchy(const ni_fsm_t *fsm)
+ni_fsm_print_config_hierarchy(const ni_fsm_t *fsm,
+		const ni_ifworker_array_t *marked, ni_log_fn_t *logfn)
 {
 	unsigned int i;
 
-	ni_debug_application("Config device hierarchy structure:");
+	ni_fsm_print_hierarchy(logfn, "Config interface hierarchy structure:");
 	if (!fsm)
 		return;
 
@@ -3724,7 +4535,8 @@ ni_fsm_print_config_hierarchy(const ni_fsm_t *fsm)
 		ni_ifworker_t *w = fsm->workers.data[i];
 
 		if (w && w->type == NI_IFWORKER_TYPE_NETDEV && !w->masterdev)
-			ni_fsm_print_config_device_worker_hierarchy(w, 0);
+			ni_fsm_print_config_device_worker_hierarchy(fsm, w,
+					0, marked, logfn);
 	}
 }
 
@@ -3734,12 +4546,25 @@ ni_fsm_print_device_name_info(ni_stringbuf_t *info, const ni_ifworker_t *w)
 	if (!info || !w || !w->device)
 		return NULL;
 
-	ni_stringbuf_printf(info, "%s[%u]", w->device->name, w->device->link.ifindex);
+	ni_stringbuf_printf(info, "%s[%u]",
+			w->device->name, w->device->link.ifindex);
 	return info->string;
 }
 
+static const char *
+ni_fsm_system_hierarchy_mark(const ni_ifworker_array_t *marked,
+		const ni_ifworker_t *w)
+{
+	if (w && marked && ni_ifworker_array_index(marked, w) != -1)
+		return "- ";
+	else
+		return "  ";
+}
+
 static void
-ni_fsm_print_system_device_worker_hierarchy(const ni_fsm_t *fsm, const ni_ifworker_t *w, unsigned int depth)
+ni_fsm_print_system_device_worker_hierarchy(const ni_fsm_t *fsm,
+		const ni_ifworker_t *w, unsigned int depth,
+		const ni_ifworker_array_t *marked, ni_log_fn_t *logfn)
 {
 	ni_stringbuf_t info = NI_STRINGBUF_INIT_DYNAMIC;
 	unsigned int i;
@@ -3748,7 +4573,9 @@ ni_fsm_print_system_device_worker_hierarchy(const ni_fsm_t *fsm, const ni_ifwork
 		return;
 
 	if (!depth) {
-		ni_debug_application("%s", ni_fsm_print_device_name_info(&info, w));
+		ni_fsm_print_hierarchy(logfn, "%s%s",
+				ni_fsm_system_hierarchy_mark(marked, w),
+				ni_fsm_print_device_name_info(&info, w));
 		ni_stringbuf_destroy(&info);
 	}
 
@@ -3760,76 +4587,83 @@ ni_fsm_print_system_device_worker_hierarchy(const ni_fsm_t *fsm, const ni_ifwork
 			continue;
 
 		if (ni_string_eq(w->device->link.lowerdev.name, c->name)) {
-			ni_debug_application("%*s %s", depth, "+--", ni_fsm_print_device_name_info(&info, c));
+
+			ni_fsm_print_hierarchy(logfn, "%s%*s %s",
+					ni_fsm_system_hierarchy_mark(marked, c),
+					depth, "+--",
+					ni_fsm_print_device_name_info(&info, c));
 			ni_stringbuf_destroy(&info);
-			ni_fsm_print_system_device_worker_hierarchy(fsm, c, depth + 1);
-		} else
+
+			ni_fsm_print_system_device_worker_hierarchy(fsm, c,
+					depth + 1, marked, logfn);
+			continue;
+		}
 		if (ni_string_eq(c->device->link.masterdev.name, w->name)) {
-			ni_debug_application("%*s %s", depth, "*--", ni_fsm_print_device_name_info(&info, c));
+
+			ni_fsm_print_hierarchy(logfn, "%s%*s %s",
+					ni_fsm_system_hierarchy_mark(marked, c),
+					depth, "*--",
+					ni_fsm_print_device_name_info(&info, c));
 			ni_stringbuf_destroy(&info);
-			ni_fsm_print_system_device_worker_hierarchy(fsm, c, depth + 1);
+
+			ni_fsm_print_system_device_worker_hierarchy(fsm, c,
+					depth + 1, marked,  logfn);
 		}
 	}
 }
 
 void
-ni_fsm_print_system_hierarchy(const ni_fsm_t *fsm)
+ni_fsm_print_system_hierarchy(const ni_fsm_t *fsm,
+		const ni_ifworker_array_t *marked, ni_log_fn_t *logfn)
 {
 	ni_ifworker_t *w;
 	unsigned int i;
 
-	ni_debug_application("System device hierarchy structure:");
+	if (!fsm)
+		return;
+
+	ni_fsm_print_hierarchy(logfn, "System interface hierarchy structure:");
 	for (i = 0; i < fsm->workers.count; ++i) {
 		w = fsm->workers.data[i];
 
-		if (w && w->type == NI_IFWORKER_TYPE_NETDEV && w->device &&
-		    ni_string_empty(w->device->link.masterdev.name))
-			ni_fsm_print_system_device_worker_hierarchy(fsm, w, 0);
+		if (!w || w->type != NI_IFWORKER_TYPE_NETDEV || !w->device)
+			continue;
+
+		if (!ni_string_empty(w->device->link.masterdev.name))
+			continue;
+
+		ni_fsm_print_system_device_worker_hierarchy(fsm, w, 0,
+				marked, logfn);
 	}
 }
 
 int
 ni_fsm_build_hierarchy(ni_fsm_t *fsm, ni_bool_t destructive)
 {
+	ni_ifworker_t *w;
 	unsigned int i;
+	int rv;
+
+	if (!fsm)
+		return NI_ERROR_INVALID_ARGS;
 
 	ni_fsm_events_block(fsm);
 	for (i = 0; i < fsm->workers.count; ++i) {
-		ni_ifworker_t *w = fsm->workers.data[i];
-		int rv;
-
-		/* A worker without an ifnode is one that we discovered in the
-		 * system, but which we've not been asked to configure. */
-		if (!w->config.node)
-			continue;
+		w = fsm->workers.data[i];
 
 		if ((rv = ni_ifworker_bind_early(w, fsm, FALSE)) < 0) {
 			if (destructive) {
-				if (-NI_ERROR_DOCUMENT_ERROR == rv)
-					ni_debug_application("%s: configuration failed", w->name);
 				ni_fsm_destroy_worker(fsm, w);
 				i--;
 			}
-		}
-	}
-
-	for (i = 0; i < fsm->workers.count; ++i) {
-		ni_ifworker_t *w = fsm->workers.data[i];
-
-		if (w->masterdev) {
-			if (!ni_ifworker_add_child_master(w->config.node, w->masterdev->name))
-				continue;
-			ni_ifworker_generate_uuid(w);
+			continue;
 		}
 	}
 
 	ni_ifworkers_break_loops(fsm);
 	ni_fsm_events_unblock(fsm);
 
-	if (ni_log_facility(NI_TRACE_APPLICATION))
-		ni_fsm_print_config_hierarchy(fsm);
-
-	return 0;
+	return NI_SUCCESS;
 }
 
 dbus_bool_t
@@ -3924,7 +4758,7 @@ ni_ifworker_netif_resolve_cb(xml_node_t *node, const ni_xs_type_t *type, const x
 			}
 
 			requires++;
-			ni_ifworker_add_check_state_req(w, method, cw, cwtype, cw ? NULL : node,
+			ni_ifworker_add_config_check_state_req(w, method, cw, cwtype, cw ? NULL : node,
 							cw ? NULL : cwmeta, min_state, max_state);
 		}
 	}
@@ -4972,6 +5806,111 @@ ni_ifworker_do_wait_device_ready_call(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_tr
 	return ni_ifworker_do_common_call(fsm, w, action);
 }
 
+static unsigned int
+ni_ifworker_get_ports_by_name(ni_fsm_t *fsm, const char *name, ni_ifworker_array_t *ports)
+{
+	unsigned int i, count;
+
+	if (!fsm || ni_string_empty(name))
+		return 0;
+
+	count = ports ? ports->count : 0;
+	for (i = 0;  i < fsm->workers.count; ++i) {
+		ni_ifworker_t *w = fsm->workers.data[i];
+
+		if (!w->masterdev)
+			continue;
+		if (!ni_string_eq(w->masterdev->name, name))
+			continue;
+
+		if (ports)
+			ni_ifworker_array_append(ports, w);
+		else
+			count++;
+	}
+	return ports ? ports->count - count : count;
+}
+
+static ni_tristate_t
+ni_ifworker_link_detection_guess(ni_fsm_t *fsm, ni_ifworker_t *w)
+{
+	ni_netdev_t *dev;
+
+	/*
+	 * At the time of this call, the interface is configured
+	 * by changeDevice (if needed), we're setting it UP (linkUp)
+	 * and when it's not defined via config, we need to decide
+	 * whether to wait for 'link-up' event signaling carrier
+	 * and running state (incl. wpa on wlan) or not, before we
+	 * continue with the L3 setup aka assign IP addresses, ...
+	 *
+	 * For some interfaces, we don't wait for link-up by default.
+	 */
+	if (!fsm || !w)
+		return NI_TRISTATE_DEFAULT;
+
+	switch (w->masterdev ? w->masterdev->iftype : NI_IFTYPE_UNKNOWN) {
+	case NI_IFTYPE_BOND:
+	case NI_IFTYPE_TEAM:
+	case NI_IFTYPE_BRIDGE:
+	case NI_IFTYPE_OVS_BRIDGE:
+	case NI_IFTYPE_OVS_SYSTEM:
+		/*
+		 * Don't wait for L2 ports controlled by master,
+		 * which inherit it's carrier from it's ports
+		 * according to own logic (incl. monitoring)
+		 * and we don't wait for link-up of the ports
+		 * and also don't setup L3 on ports.
+		 */
+		return NI_TRISTATE_DISABLE;
+	default:
+		break;
+	}
+
+	switch (w->iftype) {
+	case NI_IFTYPE_OVS_SYSTEM:
+		/*
+		 * The link state is unused on ovs datapaths.
+		 */
+		return NI_TRISTATE_DISABLE;
+
+	case NI_IFTYPE_TUN:
+	case NI_IFTYPE_TAP:
+		/*
+		 * Tun/Tap interfaces need a daemon started by
+		 * an external service, PRE_UP hook, ...
+		 * It may need to open a connection somewhere
+		 * in the internet, ... don't require link-up.
+		 */
+		return NI_TRISTATE_DISABLE;
+
+	case NI_IFTYPE_BRIDGE:
+		/*
+		 * A bridge inherits the carrier from a port;
+		 * - When the config defines ports, wait until
+		 *   they're added and the bridge gets link-up.
+		 * - When the config does not define any ports:
+		 *   - with STP=off: the bridge will get link-up
+		 *   - with STP=on: will not reach link-up until
+		 *     a port has been added externally, e.g. by
+		 *     adding a VM interface to it at VM start.
+		 *     Don't require the link-up, but continue to
+		 *     set up L3 (e.g. static IPs), so services
+		 *     (e.g. dhcp-server) are started on the
+		 *     bridge to serve the VMs (while it's added).
+		 */
+		dev = w->device; /* changeDevice is applied */
+		if (dev && dev->bridge && dev->bridge->stp &&
+		    ni_ifworker_get_ports_by_name(fsm, w->name, NULL))
+			return NI_TRISTATE_DISABLE;
+		return NI_TRISTATE_DEFAULT;
+
+	default:
+		return NI_TRISTATE_DEFAULT;
+	}
+
+}
+
 static int
 ni_ifworker_link_detection_call(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_transition_t *action)
 {
@@ -4979,8 +5918,11 @@ ni_ifworker_link_detection_call(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_transiti
 
 	ret = ni_ifworker_do_common_call(fsm, w, action);
 
-	if (!ni_tristate_is_set(w->control.link_required) && w->device)
-		w->control.link_required = ni_netdev_guess_link_required(w->device);
+	if (!ni_tristate_is_set(w->control.link_required)) {
+		w->control.link_required = ni_ifworker_link_detection_guess(fsm, w);
+		if (ni_tristate_is_set(w->control.link_required))
+			ni_ifworker_update_client_state_control(w);
+	}
 
 	if (ret >= 0 && w->fsm.wait_for) {
 		if (w->control.link_timeout != NI_IFWORKER_INFINITE_SECONDS) {
@@ -5222,6 +6164,38 @@ static ni_fsm_transition_t	ni_iftransitions[] = {
 	{ .from_state = NI_FSM_STATE_NONE, .next_state = NI_FSM_STATE_NONE, .call_func = NULL }
 };
 
+static const ni_fsm_transition_t *
+ni_fsm_transition_first(void)
+{
+	const ni_fsm_transition_t *action = ni_iftransitions;
+
+	if (action && action->call_func)
+		return action;
+	return NULL;
+}
+
+static const ni_fsm_transition_t *
+ni_fsm_transition_next(const ni_fsm_transition_t *action)
+{
+	if (!action || !action->call_func)
+		return NULL;
+	if (++action && action->call_func)
+		return action;
+	return NULL;
+}
+
+static const ni_fsm_transition_t *
+ni_fsm_transition_find_method(const char *method)
+{
+	const ni_fsm_transition_t *action = ni_fsm_transition_first();
+
+	for ( ; action; action = ni_fsm_transition_next(action)) {
+		if (ni_string_eq(method, action->common.method_name))
+			return action;
+	}
+	return NULL;
+}
+
 static int
 ni_fsm_schedule_init(ni_fsm_t *fsm, ni_ifworker_t *w, unsigned int from_state, unsigned int target_state)
 {
@@ -5666,9 +6640,6 @@ ni_fsm_process_worker_event(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_event_t *ev)
 	switch (event_type) {
 	case NI_EVENT_DEVICE_READY:
 	case NI_EVENT_DEVICE_UP:
-		/* Rebuild hierarchy in case a new device shows up */
-		ni_fsm_build_hierarchy(fsm, FALSE);
-
 		/* Handle devices which were not present on ifup */
 		if(w->pending) {
 			w->pending = FALSE;
@@ -5755,15 +6726,8 @@ ni_fsm_process_worker_event(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_event_t *ev)
 
 	ni_ifworker_advance_state(w, event_type);
 
-	if (event_type == NI_EVENT_DEVICE_DELETE) {
-		if (ni_ifworker_is_factory_device(w))
-			ni_ifworker_device_delete(w);
-		else
-			ni_fsm_destroy_worker(fsm, w);
-
-		/* Rebuild hierarchy since one device is gone */
-		ni_fsm_build_hierarchy(fsm, FALSE);
-	}
+	if (event_type == NI_EVENT_DEVICE_DELETE)
+		ni_ifworker_device_delete(w);
 
 done: ;
 }
